package thyyxxk.webserver.utils;


import lombok.extern.slf4j.Slf4j;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.List;

/**
 * <p>
 * 描述： 实体类中去掉字符传的前后空格
 * </p>
 *
 * @author xc
 * @date 2022-01-07 14:51
 */
@Slf4j
public class EntityStringTrim {

    /**
     * 去掉bean中所有属性为字符串的前后空格
     *
     * @param bean 实体类
     * @throws Exception 错误信息
     */
    public static void beanAttributeValueTrim(Object bean) {
        if (bean != null) {
            //获取所有的字段包括public,private,protected,private
            Field[] fields = bean.getClass().getDeclaredFields();
            for (Field f : fields) {
                // 判断这个字段是不是 string 类型
                if (f.getType().equals(String.class)) {
                    try {
                        // 获取字段名 在实体类中是什么样子这里就是什么样子
                        String key = f.getName();
                        Object value = getFieldValue(bean, key);
                        if (value != null) {
                            // 值为 true 则指示反射的对象在使用时应该取消 Java 语言访问检查。
                            // 值为 false 则指示反射的对象应该实施 Java 语言访问检查
                            // 由于JDK的安全检查耗时较多.所以通过setAccessible(true)的方式关闭安全检查就可以达到提升反射速度的目的
                            f.setAccessible(true);
                            // set 新的值
                            f.set(bean, value.toString().trim());
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    /**
     * list 类型取 前后空格
     *
     * @param list list
     */
    public static void beanAttributeValueTrimList(List<?> list) {
        if (list != null && !list.isEmpty()) {
            for (Object o : list) {
                beanAttributeValueTrim(o);
            }
        }
    }

    /**
     * 利用反射通过get方法获取bean中字段fieldName的值
     *
     * @param bean      实体类
     * @param fieldName 实体类中的字段名称
     * @return 返回 实体类的值
     * @throws Exception 捕获异常
     */
    public static Object getFieldValue(Object bean, String fieldName)
            throws Exception {

        // 在这里 拼接 get 方法
        // 如 private String id
        // 转化成 getId
        String methodName = "get" +
                fieldName.substring(0, 1).toUpperCase() +
                fieldName.substring(1);

        Method method;

        // 当你的编码可能存在警告时，比如安全警告，可以用它来消除
        @SuppressWarnings("rawtypes")
        Class[] classArr = new Class[0];
        // 获取到这个类的 public 方法
        method = bean.getClass().getMethod(methodName, classArr);
        return method.invoke(bean);
    }

    /**
     * 利用发射调用bean.set方法将value设置到字段
     * <p>
     * 这个暂时时没有用到
     *
     * @param bean
     * @param fieldName
     * @param value
     * @throws Exception
     */
    private static void setFieldValue(Object bean, String fieldName, Object value)
            throws Exception {
        String methodName = "set" +
                fieldName.substring(0, 1).toUpperCase() +
                fieldName.substring(1);
        /*
          利用发射调用bean.set方法将value设置到字段
         */
        @SuppressWarnings("rawtypes")
        Class[] classArr = new Class[1];
        classArr[0] = "java.lang.String".getClass();
        Method method = bean.getClass().getMethod(methodName, classArr);
        method.invoke(bean, value);
    }
}
